Index: squid/src/ssl.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ssl.c,v
retrieving revision 1.3.6.9
retrieving revision 1.3.6.10
diff -u -r1.3.6.9 -r1.3.6.10
--- squid/src/ssl.c	1 Jul 2007 08:34:29 -0000	1.3.6.9
+++ squid/src/ssl.c	2 Jul 2007 07:37:03 -0000	1.3.6.10
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ssl.c,v 1.3.6.9 2007/07/01 08:34:29 amosjeffries Exp $
+ * $Id: ssl.c,v 1.3.6.10 2007/07/02 07:37:03 amosjeffries Exp $
  *
  * DEBUG: section 26    Secure Sockets Layer Proxy
  * AUTHOR: Duane Wessels
@@ -36,8 +36,6 @@
 #include "squid.h"
 
 typedef struct {
-    hash_link hash;		/* dummy, must be first */
-    int ia_cur;
     char *url;
     char *host;			/* either request->host or proxy host */
     u_short port;
@@ -65,7 +63,6 @@
 static PF sslReadClient;
 static PF sslReadServer;
 static PF sslTimeout;
-static void sslConnectTimeout(int fd, void *data);
 static PF sslWriteClient;
 static PF sslWriteServer;
 static PSC sslPeerSelectComplete;
@@ -408,6 +405,7 @@
     comm_close(sslState->client.fd);
 }
 
+
 static void
 sslConnectDone(int fd, int status, void *data)
 {
@@ -432,50 +430,6 @@
 	err->callback = sslErrorComplete;
 	err->callback_data = sslState;
 	errorSend(sslState->client.fd, err);
-    } else if (status == COMM_ERR_INV_ARGS) {
-	int newsock;
-	struct sockaddr_storage cursockaddr, newsockaddr;
-	socklen_t cursocklen = sizeof(cursockaddr);
-
-	getsockname(fd, (struct sockaddr *)&cursockaddr, &cursocklen);
-	memset(&newsockaddr, '\0', sizeof(newsockaddr));
-	if (cursockaddr.ss_family == AF_INET6)
-	    newsockaddr.ss_family = AF_INET;
-	else
-	    newsockaddr.ss_family = AF_INET6;
-	newsock = comm_openex(SOCK_STREAM,
-		IPPROTO_TCP,
-		(struct sockaddr*)&newsockaddr,
-		COMM_NONBLOCKING,
-		0,
-		sslState->url);
-	if (newsock == COMM_ERROR) {
-	    debug(26, 4) ("sslStart: Failed because we're out of sockets.\n");
-	    err = errorCon(ERR_SOCKET_FAILURE, HTTP_INTERNAL_SERVER_ERROR, request);
-	    err->xerrno = errno;
-	    err->callback = sslErrorComplete;
-	    err->callback_data = sslState;
-	    errorSend(sslState->client.fd, err);
-	    return;
-	}
-	comm_remove_close_handler(sslState->server.fd,
-		sslServerClosed,
-		sslState);
-	comm_close(sslState->server.fd);
-	sslState->server.fd = newsock;
-	comm_add_close_handler(sslState->server.fd,
-		sslServerClosed,
-		sslState);
-	sslSetSelect(sslState);
-	commSetTimeout(sslState->server.fd,
-		Config.Timeout.connect,
-		sslConnectTimeout,
-		sslState);
-	commConnectStart(sslState->server.fd,
-		sslState->host, sslState->port,
-		sslConnectDone,
-		sslState,
-                &newsockaddr);
     } else if (status != COMM_OK) {
 	comm_close(fd);
 	err = errorCon(ERR_CONNECT_FAIL, HTTP_SERVICE_UNAVAILABLE, request);
@@ -536,18 +490,14 @@
     int fd = http->conn->fd;
     request_t *request = http->request;
     char *url = http->uri;
-    struct sockaddr_storage outgoing;
+    struct in_addr outgoing;
     unsigned long tos;
-    struct sockaddr_storage addr;
     /*
      * client_addr == no_addr indicates this is an "internal" request
      * from peer_digest.c, asn.c, netdb.c, etc and should always
      * be allowed.  yuck, I know.
      */
-    if ( ((request->client_addr.ss_family == AF_INET6) &&
-      !IN6_IS_ADDR_ALLF(&((struct sockaddr_in6 *)&request->client_addr)->sin6_addr)) ||
-      ((request->client_addr.ss_family == AF_INET) &&
-      (((struct sockaddr_in *)&request->client_addr)->sin_addr.s_addr != no_addr.s_addr))) {
+    if (request->client_addr.s_addr != no_addr.s_addr) {
 	/*
 	 * Check if this host is allowed to fetch MISSES from us (miss_access)
 	 */
@@ -563,13 +513,15 @@
 	RequestMethods[request->method].str, url);
     statCounter.server.all.requests++;
     statCounter.server.other.requests++;
+    outgoing = getOutgoingAddr(request);
+    tos = getOutgoingTOS(request);
     /* Create socket. */
-    memset(&addr, '\0', sizeof(addr));
-    addr.ss_family = AF_INET;
-    sock = comm_open(SOCK_STREAM,
+    sock = comm_openex(SOCK_STREAM,
 	IPPROTO_TCP,
-	&addr,
+	outgoing,
+	0,
 	COMM_NONBLOCKING,
+	tos,
 	url);
     if (sock == COMM_ERROR) {
 	debug(26, 4) ("sslStart: Failed because we're out of sockets.\n");
@@ -595,8 +547,7 @@
     sslState->client.buf = xmalloc(SQUID_TCP_SO_RCVBUF);
     /* Copy any pending data from the client connection */
     sslState->client.len = http->conn->in.offset;
-// AYJ: 'outgoing' in uninitialised local variable.    sslState->request->out_ip = outgoing;
-    sslState->ia_cur = -1;
+    sslState->request->out_ip = outgoing;
     if (sslState->client.len > 0) {
 	if (sslState->client.len > SQUID_TCP_SO_RCVBUF) {
 	    safe_free(sslState->client.buf);
@@ -655,13 +606,9 @@
 static void
 sslPeerSelectComplete(FwdServer * fs, void *data)
 {
-    struct sockaddr_storage sslsock, cursockaddr;
-    ErrorState *err = NULL;
-    int newsock = -1;
     SslStateData *sslState = data;
     request_t *request = sslState->request;
     peer *g = NULL;
-    socklen_t cursocklen = sizeof(cursockaddr);
     if (fs == NULL) {
 	ErrorState *err;
 	err = errorCon(ERR_CANNOT_FORWARD, HTTP_SERVICE_UNAVAILABLE, sslState->request);
@@ -672,14 +619,7 @@
 	return;
     }
     sslState->servers = fs;
-    sslState->host = fs->peer ? NULL : request->host;
-    if (fs->peer) 
-	xmemcpy(&sslsock, &fs->peer->in_addr, sizeof(struct sockaddr_storage));
-    else
-	memset(&sslsock, '\0', sizeof(struct sockaddr_storage));
-/*
-	xmemcpy(&sslsock, &request->client_addr, sizeof(struct sockaddr_storage));
-*/
+    sslState->host = fs->peer ? fs->peer->host : request->host;
     if (fs->peer == NULL) {
 	sslState->port = request->port;
     } else if (fs->peer->http_port != 0) {
@@ -703,44 +643,13 @@
 	sslState->delay_id = 0;
     }
 #endif
-    if (sslsock.ss_family == AF_INET6)
-	((struct sockaddr_in6 *)&sslsock)->sin6_port = sslState->port;
-    else
-	((struct sockaddr_in *)&sslsock)->sin_port = sslState->port;
-    getsockname(sslState->server.fd, (struct sockaddr *)&cursockaddr, &cursocklen);
-    if (!sslState->host && cursockaddr.ss_family != sslsock.ss_family) {
-    memset(&cursockaddr, '\0', sizeof(cursockaddr));
-    cursockaddr.ss_family = sslsock.ss_family;
-    newsock = comm_openex(SOCK_STREAM,
-	IPPROTO_TCP,
-	&cursockaddr,
-	COMM_NONBLOCKING,
-	0,
-	sslState->url);
-    if (newsock == COMM_ERROR) {
-	debug(26, 4) ("sslStart: Failed because we're out of sockets.\n");
-	err = errorCon(ERR_SOCKET_FAILURE, HTTP_INTERNAL_SERVER_ERROR, request);
-	err->xerrno = errno;
-	errorSend(sslState->client.fd, err);
-	return;
-    }
-    comm_remove_close_handler(sslState->server.fd,
-	sslServerClosed,
-	sslState);
-    comm_close(sslState->server.fd);
-
-    sslState->server.fd = newsock;
-    comm_add_close_handler(sslState->server.fd,
-	sslServerClosed,
-	sslState);
-    sslSetSelect(sslState);
-    }
     commSetTimeout(sslState->server.fd,
 	Config.Timeout.connect,
 	sslConnectTimeout,
 	sslState);
     commConnectStart(sslState->server.fd,
-	sslState->host, sslState->port,
+	sslState->host,
+	sslState->port,
 	sslConnectDone,
 	sslState,
 	NULL);
Index: squid/src/stat.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/stat.c,v
retrieving revision 1.4.6.7
retrieving revision 1.4.6.8
diff -u -r1.4.6.7 -r1.4.6.8
--- squid/src/stat.c	1 Jul 2007 05:44:24 -0000	1.4.6.7
+++ squid/src/stat.c	2 Jul 2007 07:37:03 -0000	1.4.6.8
@@ -1,6 +1,6 @@
 
 /*
- * $Id: stat.c,v 1.4.6.7 2007/07/01 05:44:24 amosjeffries Exp $
+ * $Id: stat.c,v 1.4.6.8 2007/07/02 07:37:03 amosjeffries Exp $
  *
  * DEBUG: section 18    Cache Manager Statistics
  * AUTHOR: Harvest Derived
@@ -1460,7 +1460,6 @@
     ConnStateData *conn;
     StoreEntry *e;
     int fd;
-    char host[100], port[8];
     for (i = ClientActiveRequests.head; i; i = i->next) {
 	const char *p = NULL;
 	http = i->data;
@@ -1474,12 +1473,12 @@
 	    storeAppendPrintf(s, "\tFD desc: %s\n", fd_table[fd].desc);
 	    storeAppendPrintf(s, "\tin: buf %p, offset %ld, size %ld\n",
 		conn->in.buf, (long int) conn->in.offset, (long int) conn->in.size);
-	    getnameinfo(&conn->peer, sizeof(struct sockaddr_storage),
-		host, 100, port, 8, NI_NUMERICHOST|NI_NUMERICSERV);
-	    storeAppendPrintf(s, "\tpeer: %s:%s\n", host, port);
-	    getnameinfo(&conn->me, sizeof(struct sockaddr_storage),
-		host, 100, port, 8, NI_NUMERICHOST|NI_NUMERICSERV);
-	    storeAppendPrintf(s, "\tme: %s:%s\n", host, port);
+	    storeAppendPrintf(s, "\tpeer: %s:%d\n",
+		inet_ntoa(conn->peer.sin_addr),
+		ntohs(conn->peer.sin_port));
+	    storeAppendPrintf(s, "\tme: %s:%d\n",
+		inet_ntoa(conn->me.sin_addr),
+		ntohs(conn->me.sin_port));
 	    storeAppendPrintf(s, "\tnrequests: %d\n",
 		conn->nrequests);
 	    storeAppendPrintf(s, "\tdefer: n %d, until %ld\n",
Index: squid/src/structs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/structs.h,v
retrieving revision 1.7.2.12
retrieving revision 1.7.2.13
diff -u -r1.7.2.12 -r1.7.2.13
--- squid/src/structs.h	1 Jul 2007 08:34:29 -0000	1.7.2.12
+++ squid/src/structs.h	2 Jul 2007 07:37:03 -0000	1.7.2.13
@@ -1,6 +1,6 @@
 
 /*
- * $Id: structs.h,v 1.7.2.12 2007/07/01 08:34:29 amosjeffries Exp $
+ * $Id: structs.h,v 1.7.2.13 2007/07/02 07:37:03 amosjeffries Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -72,9 +72,9 @@
 };
 
 struct _acl_ip_data {
-    struct sockaddr_storage addr1;	/* if addr2 non-zero then its a range */
-    struct sockaddr_storage addr2;
-    int masklen;
+    struct in_addr addr1;	/* if addr2 non-zero then its a range */
+    struct in_addr addr2;
+    struct in_addr mask;
     acl_ip_data *next;		/* used for parsing, not for storing */
 };
 
@@ -114,7 +114,7 @@
 struct _auth_user_ip_t {
     dlink_node node;
     /* IP addr this user authenticated from */
-    struct sockaddr_storage ipaddr;
+    struct in_addr ipaddr;
     time_t ip_expiretime;
 };
 
@@ -254,7 +254,7 @@
     int sock;
     long reqid;
     int outlen;
-    struct in_addr from;
+    struct sockaddr_in from;
     struct snmp_pdu *PDU;
     aclCheck_t *acl_checklist;
     u_char *community;
@@ -287,7 +287,7 @@
 struct _acl_address {
     acl_address *next;
     acl_list *acl_list;
-    struct sockaddr_storage addr;
+    struct in_addr addr;
 };
 
 struct _acl_tos {
@@ -298,9 +298,9 @@
 
 struct _aclCheck_t {
     const acl_access *access_list;
-    struct sockaddr_storage src_addr;
-    struct sockaddr_storage dst_addr;
-    struct sockaddr_storage my_addr;
+    struct in_addr src_addr;
+    struct in_addr dst_addr;
+    struct in_addr my_addr;
     unsigned short my_port;
     request_t *request;
     /* for acls that look at reply data */
@@ -351,14 +351,14 @@
     unsigned int internal:1;
 };
 
-struct _sockaddr_storage_list {
-    struct sockaddr_storage s;
-    sockaddr_storage_list *next;
+struct _sockaddr_in_list {
+    struct sockaddr_in s;
+    sockaddr_in_list *next;
 };
 
 struct _http_port_list {
     http_port_list *next;
-    struct sockaddr_storage s;
+    struct sockaddr_in s;
     char *protocol;		/* protocol name */
     char *name;			/* visible name */
     char *defaultsite;		/* default web site */
@@ -492,15 +492,15 @@
 #endif
 #if USE_WCCP
     struct {
-	struct sockaddr_storage router;
-	struct sockaddr_storage address;
+	struct in_addr router;
+	struct in_addr address;
 	int version;
     } Wccp;
 #endif
 #if USE_WCCPv2
     struct {
-	sockaddr_storage_list *router;
-	struct sockaddr_storage address;
+	sockaddr_in_list *router;
+	struct in_addr address;
 	int forwarding_method;
 	int return_method;
 	int assignment_method;
@@ -581,17 +581,13 @@
 	u_short port;
     } Announce;
     struct {
-	struct sockaddr_storage udp_incoming;
-	struct sockaddr_storage udp_outgoing;
+	struct in_addr udp_incoming;
+	struct in_addr udp_outgoing;
 #if SQUID_SNMP
-	struct sockaddr_storage snmp_incoming;
-	struct sockaddr_storage snmp_outgoing;
+	struct in_addr snmp_incoming;
+	struct in_addr snmp_outgoing;
 #endif
-	struct sockaddr_storage client_netmask;
-	struct sockaddr_storage udp6_incoming;
-	struct sockaddr_storage udp6_outgoing;
-	int client_masklen;
-	int client6_masklen;
+	struct in_addr client_netmask;
     } Addrs;
     squid_off_t tcpRcvBufsz;
     squid_off_t udpMaxHitObjsz;
@@ -760,7 +756,7 @@
     squid_off_t rangeOffsetLimit;
 #if MULTICAST_MISS_STREAM
     struct {
-	struct sockaddr_storage addr;
+	struct in_addr addr;
 	int ttl;
 	unsigned short port;
 	char *encode_key;
@@ -870,9 +866,9 @@
     unsigned int type;
     u_short local_port;
     u_short remote_port;
-    struct sockaddr_storage local_addr;
+    struct in_addr local_addr;
     unsigned char tos;
-    char ipaddr[80];		/* dotted decimal address of peer */
+    char ipaddr[16];		/* dotted decimal address of peer */
     const char *desc;
     char descbuf[FD_DESC_SZ];
     struct {
@@ -1119,7 +1115,7 @@
 };
 
 struct _icpUdpData {
-    struct sockaddr_storage address;
+    struct sockaddr_in address;
     void *msg;
     size_t len;
     icpUdpData *next;
@@ -1166,8 +1162,8 @@
 	icp_opcode opcode;
     } icp;
     struct {
-	struct sockaddr_storage caddr;
-	struct sockaddr_storage out_ip;
+	struct in_addr caddr;
+	struct in_addr out_ip;
 	squid_off_t size;
 	size_t rq_size;
 	log_type code;
@@ -1264,9 +1260,9 @@
     /* the user details for connection based authentication */
     auth_user_request_t *auth_user_request;
     dlink_list reqs;
-    struct sockaddr_storage peer;
-    struct sockaddr_storage me;
-    struct sockaddr_storage log_addr;
+    struct sockaddr_in peer;
+    struct sockaddr_in me;
+    struct in_addr log_addr;
     char rfc931[USER_IDENT_SZ];
     int nrequests;
     struct {
@@ -1286,7 +1282,7 @@
 };
 
 struct _ipcache_addrs {
-    struct sockaddr_storage *in_addrs;
+    struct in_addr *in_addrs;
     unsigned char *bad_mask;
     unsigned char count;
     unsigned char cur;
@@ -1386,12 +1382,10 @@
 #endif
 
 struct _peer {
-    hash_link hash; /* dummy, must be first */
-    int ia_cur;
     char *name;
     char *host;
     peer_t type;
-    struct sockaddr_storage in_addr;
+    struct sockaddr_in in_addr;
     struct {
 	int pings_sent;
 	int pings_acked;
@@ -1465,7 +1459,7 @@
     char *digest_url;
 #endif
     int tcp_up;			/* 0 if a connect() fails */
-    struct sockaddr_storage addresses[10];
+    struct in_addr addresses[10];
     int n_addresses;
     int rr_count;
     int rr_lastcount;
@@ -1559,14 +1553,14 @@
     void *callback_data;
     FwdServer *servers;
     /*
-     * Why are these struct sockaddr_storage instead of peer *?  Because a
+     * Why are these struct sockaddr_in instead of peer *?  Because a
      * peer structure can become invalid during the peer selection
      * phase, specifically after a reconfigure.  Thus we need to lookup
      * the peer * based on the address when we are finally ready to
      * reference the peer structure.
      */
-    struct sockaddr_storage first_parent_miss;
-    struct sockaddr_storage closest_parent_miss;
+    struct sockaddr_in first_parent_miss;
+    struct sockaddr_in closest_parent_miss;
     /*
      * ->hit and ->secho can be peer* because they should only be
      * accessed during the thread when they are set
@@ -1582,14 +1576,14 @@
 
 #if USE_ICMP
 struct _pingerEchoData {
-    struct sockaddr_storage to;
+    struct in_addr to;
     unsigned char opcode;
     int psize;
     char payload[PINGER_PAYLOAD_SZ];
 };
 
 struct _pingerReplyData {
-    struct sockaddr_storage from;
+    struct in_addr from;
     unsigned char opcode;
     int rtt;
     int hops;
@@ -1606,7 +1600,7 @@
     u_num32 reqnum;		/* req number (req'd for UDP) */
     u_num32 flags;
     u_num32 pad;
-    struct sockaddr_storage shostid;		/* sender host id */
+    u_num32 shostid;		/* sender host id */
 };
 
 struct _iostats {
@@ -1889,12 +1883,13 @@
     time_t ims;
     int imslen;
     int max_forwards;
+    /* these in_addr's could probably be sockaddr_in's */
     unsigned short client_port;
-    struct sockaddr_storage client_addr;
+    struct in_addr client_addr;
 #if FOLLOW_X_FORWARDED_FOR
-    struct sockaddr_storage indirect_client_addr;	/* after following X-Forwarded-For */
+    struct in_addr indirect_client_addr;	/* after following X-Forwarded-For */
 #endif				/* FOLLOW_X_FORWARDED_FOR */
-    struct sockaddr_storage my_addr;
+    struct in_addr my_addr;
     unsigned short my_port;
     HttpHeader header;
     squid_off_t content_length;
@@ -1913,7 +1908,7 @@
     char *peer_domain;		/* Configured peer forceddomain */
     BODY_HANDLER *body_reader;
     void *body_reader_data;
-    struct sockaddr_storage out_ip;
+    struct in_addr out_ip;
     String extacl_log;		/* String to be used for access.log purposes */
     const char *extacl_user;	/* User name returned by extacl lookup */
     const char *extacl_passwd;	/* Password returned by extacl lookup */
@@ -1962,7 +1957,7 @@
     int xerrno;
     char *dnsserver_msg;
     time_t ttl;
-    struct sockaddr_storage src_addr;
+    struct in_addr src_addr;
     char *redirect_url;
     ERCB *callback;
     void *callback_data;
@@ -2203,7 +2198,7 @@
 
 struct _ClientInfo {
     hash_link hash;		/* must be first */
-    struct sockaddr_storage addr;
+    struct in_addr addr;
     struct {
 	int result_hist[LOG_TYPE_MAX];
 	int n_requests;
@@ -2237,15 +2232,11 @@
 };
 
 struct _FwdState {
-    hash_link hash;	/* dummy, must be first */
-    int ia_cur;
     int client_fd;		/* XXX unnecessary */
     StoreEntry *entry;
     request_t *request;
     FwdServer *servers;
     int server_fd;
-    int server_fd_was_v4;
-    int server_fd_was_inv_args;
     ErrorState *err;
     time_t start;
     int n_tries;
@@ -2258,7 +2249,7 @@
 	unsigned int ftp_pasv_failed:1;
     } flags;
 #if LINUX_NETFILTER
-    struct sockaddr_storage src;
+    struct sockaddr_in src;
 #endif
 };
 
Index: squid/src/tools.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/tools.c,v
retrieving revision 1.4.2.12
retrieving revision 1.4.2.13
diff -u -r1.4.2.12 -r1.4.2.13
--- squid/src/tools.c	1 Jul 2007 08:34:30 -0000	1.4.2.12
+++ squid/src/tools.c	2 Jul 2007 07:37:03 -0000	1.4.2.13
@@ -1,6 +1,6 @@
 
 /*
- * $Id: tools.c,v 1.4.2.12 2007/07/01 08:34:30 amosjeffries Exp $
+ * $Id: tools.c,v 1.4.2.13 2007/07/02 07:37:03 amosjeffries Exp $
  *
  * DEBUG: section 21    Misc Functions
  * AUTHOR: Harvest Derived
@@ -499,10 +499,10 @@
     host[0] = '\0';
     memcpy(&sa, &any_addr, sizeof(sa));
     if (Config.Sockaddr.http && sa.s_addr == any_addr.s_addr)
-	memcpy(&sa, &((struct sockaddr_in *)&Config.Sockaddr.http->s)->sin_addr, sizeof(sa));
+	memcpy(&sa, &Config.Sockaddr.http->s.sin_addr, sizeof(sa));
 #if USE_SSL
     if (Config.Sockaddr.https && sa.s_addr == any_addr.s_addr)
-	memcpy(&sa, &((struct sockaddr_in *)&Config.Sockaddr.https->http.s)->sin_addr, sizeof(sa));
+	memcpy(&sa, &Config.Sockaddr.https->http.s.sin_addr, sizeof(sa));
 #endif
     /*
      * If the first http_port address has a specific address, try a
@@ -1312,10 +1312,10 @@
 getMyPort(void)
 {
     if (Config.Sockaddr.http)
-	return ntohs(((struct sockaddr_in *)&Config.Sockaddr.http->s)->sin_port);
+	return ntohs(Config.Sockaddr.http->s.sin_port);
 #if USE_SSL
     if (Config.Sockaddr.https)
-	return ntohs(((struct sockaddr_in *)&Config.Sockaddr.https->http.s)->sin_port);
+	return ntohs(Config.Sockaddr.https->http.s.sin_port);
 #endif
     fatal("No port defined");
     return 0;			/* NOT REACHED */
@@ -1363,15 +1363,6 @@
 #endif
 }
 
-char *
-sockaddr_ntoa(struct sockaddr_storage *addr)
-{
-    static char host[100];
-    memset(host, '\0', 100);
-    getnameinfo((struct sockaddr *)addr, SOCKLEN(addr), host, 100, NULL, 0, NI_NUMERICHOST);
-    return host;
-}
-
 /* XXX this is ipv4-only aware atm */
 const char *
 xinet_ntoa(const struct in_addr addr)
Index: squid/src/typedefs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/typedefs.h,v
retrieving revision 1.4.2.7
retrieving revision 1.4.2.8
diff -u -r1.4.2.7 -r1.4.2.8
--- squid/src/typedefs.h	1 Jul 2007 05:44:25 -0000	1.4.2.7
+++ squid/src/typedefs.h	2 Jul 2007 07:37:04 -0000	1.4.2.8
@@ -1,6 +1,6 @@
 
 /*
- * $Id: typedefs.h,v 1.4.2.7 2007/07/01 05:44:25 amosjeffries Exp $
+ * $Id: typedefs.h,v 1.4.2.8 2007/07/02 07:37:04 amosjeffries Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -108,7 +108,7 @@
 typedef struct _intrange intrange;
 typedef struct _ushortlist ushortlist;
 typedef struct _relist relist;
-typedef struct _sockaddr_storage_list sockaddr_storage_list;
+typedef struct _sockaddr_in_list sockaddr_in_list;
 typedef struct _http_port_list http_port_list;
 typedef struct _https_port_list https_port_list;
 typedef struct _SquidConfig SquidConfig;
Index: squid/src/url.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/url.c,v
retrieving revision 1.3.6.7
retrieving revision 1.3.6.8
diff -u -r1.3.6.7 -r1.3.6.8
--- squid/src/url.c	1 Jul 2007 08:34:30 -0000	1.3.6.7
+++ squid/src/url.c	2 Jul 2007 07:37:04 -0000	1.3.6.8
@@ -1,6 +1,6 @@
 
 /*
- * $Id: url.c,v 1.3.6.7 2007/07/01 08:34:30 amosjeffries Exp $
+ * $Id: url.c,v 1.3.6.8 2007/07/02 07:37:04 amosjeffries Exp $
  *
  * DEBUG: section 23    URL Parsing
  * AUTHOR: Duane Wessels
@@ -110,8 +110,6 @@
 };
 
 static request_t *urnParse(method_t method, char *urn);
-static const char valid_ipv6_addr_chars[] =
-"ABCDEFabcdef0123456789:";
 static const char valid_hostname_chars_u[] =
 "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
 "abcdefghijklmnopqrstuvwxyz"
@@ -343,10 +341,7 @@
 	    strcpy((char *) host, t + 1);
 	}
 	/* Is there any host information? (we should eventually parse it above) */
-        q = host;
-        if (strchr(host, '[') && strchr(host, ']'))
-            q =  strchr(host, ']');
-        if ((t = strrchr(q, ':'))) {
+	if ((t = strrchr(host, ':'))) {
 	    *t++ = '\0';
 	    if (*t != '\0')
 		port = atoi(t);
@@ -365,20 +360,12 @@
 	    *q = '\0';
 	}
     }
-    if (host == strrchr(host, '[') && 
-	(host + strlen(host)-1) == strchr(host, ']')) {
-	if (strspn(host+1, valid_ipv6_addr_chars) != strlen(host)-2) { /* IPv6 address */
-	    debug(23, 1) ("urlParse: Illegal character in hostname '%s'\n", host);
-	    return NULL;
-	}
-    } else {
-	if (Config.onoff.check_hostnames && strspn(host, Config.onoff.allow_underscore ? valid_hostname_chars_u : valid_hostname_chars) != strlen(host)) {
-	    debug(23, 1) ("urlParse: Illegal character in hostname '%s'\n", host);
-	    return NULL;
-	}
-	if (Config.appendDomain && !strchr(host, '.'))
-	    strncat(host, Config.appendDomain, SQUIDHOSTNAMELEN - strlen(host) - 1);
+    if (Config.onoff.check_hostnames && strspn(host, Config.onoff.allow_underscore ? valid_hostname_chars_u : valid_hostname_chars) != strlen(host)) {
+	debug(23, 1) ("urlParse: Illegal character in hostname '%s'\n", host);
+	return NULL;
     }
+    if (Config.appendDomain && !strchr(host, '.'))
+	strncat(host, Config.appendDomain, SQUIDHOSTNAMELEN - strlen(host) - 1);
     /* remove trailing dots from hostnames */
     while ((l = strlen(host)) > 0 && host[--l] == '.')
 	host[l] = '\0';
@@ -425,12 +412,7 @@
 	}
     }
     request = requestCreate(method, protocol, urlpath);
-    if (strchr(host, '[')) {
-	xstrncpy(request->host, host+1, SQUIDHOSTNAMELEN);
-	request->host[strlen(host)-2] = '\0';
-    }
-    else
-	xstrncpy(request->host, host, SQUIDHOSTNAMELEN);
+    xstrncpy(request->host, host, SQUIDHOSTNAMELEN);
     xstrncpy(request->login, login, MAX_LOGIN_SZ);
     request->port = (u_short) port;
     return request;
@@ -446,7 +428,6 @@
 const char *
 urlCanonical(request_t * request)
 {
-    LOCAL_ARRAY(char, hostbuf, MAX_URL);
     LOCAL_ARRAY(char, portbuf, 32);
     LOCAL_ARRAY(char, urlbuf, MAX_URL);
     if (request->canonical)
@@ -462,17 +443,11 @@
 	    portbuf[0] = '\0';
 	    if (request->port != urlDefaultPort(request->protocol))
 		snprintf(portbuf, 32, ":%d", request->port);
-
-            if (strchr(request->host, ':'))
-                snprintf(hostbuf, MAX_URL, "[%s]", request->host);
-            else
-                snprintf(hostbuf, MAX_URL, "%s", request->host);
-
 	    snprintf(urlbuf, MAX_URL, "%s://%s%s%s%s%s",
 		ProtocolStr[request->protocol],
 		request->login,
 		*request->login ? "@" : null_string,
-		hostbuf,
+		request->host,
 		portbuf,
 		strBuf(request->urlpath));
 	    break;
@@ -489,7 +464,6 @@
 char *
 urlCanonicalClean(const request_t * request)
 {
-    LOCAL_ARRAY(char, hostbuf, MAX_URL);
     LOCAL_ARRAY(char, buf, MAX_URL);
     LOCAL_ARRAY(char, portbuf, 32);
     LOCAL_ARRAY(char, loginbuf, MAX_LOGIN_SZ + 1);
@@ -503,11 +477,7 @@
     } else {
 	switch (request->method) {
 	case METHOD_CONNECT:
-	    if (strchr(request->host, ':')) 
-		snprintf(hostbuf, MAX_URL, "[%s]", request->host);
-	    else
-		snprintf(hostbuf, MAX_URL, "%s", request->host);
-	    snprintf(buf, MAX_URL, "%s:%d", hostbuf, request->port);
+	    snprintf(buf, MAX_URL, "%s:%d", request->host, request->port);
 	    break;
 	default:
 	    portbuf[0] = '\0';
Index: squid/src/wccp.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/wccp.c,v
retrieving revision 1.3.6.5
retrieving revision 1.3.6.6
diff -u -r1.3.6.5 -r1.3.6.6
--- squid/src/wccp.c	1 Jul 2007 05:44:26 -0000	1.3.6.5
+++ squid/src/wccp.c	2 Jul 2007 07:37:04 -0000	1.3.6.6
@@ -1,6 +1,6 @@
 
 /*
- * $Id: wccp.c,v 1.3.6.5 2007/07/01 05:44:26 amosjeffries Exp $
+ * $Id: wccp.c,v 1.3.6.6 2007/07/02 07:37:04 amosjeffries Exp $
  *
  * DEBUG: section 80    WCCP Support
  * AUTHOR: Glenn Chisholm
@@ -112,7 +112,7 @@
     last_id = 0;
     last_assign_buckets_change = 0;
     number_caches = 0;
-    if (((struct sockaddr_in *)&Config.Wccp.router)->sin_addr.s_addr != any_addr.s_addr)
+    if (Config.Wccp.router.s_addr != any_addr.s_addr)
 	if (!eventFind(wccpHereIam, NULL))
 	    eventAdd("wccpHereIam", wccpHereIam, NULL, 5.0, 1);
 }
@@ -124,17 +124,14 @@
     struct sockaddr_in router, local;
     socklen_t local_len, router_len;
     debug(80, 5) ("wccpConnectionOpen: Called\n");
-    if (((struct sockaddr_in *)&Config.Wccp.router)->sin_addr.s_addr == any_addr.s_addr) {
+    if (Config.Wccp.router.s_addr == any_addr.s_addr) {
 	debug(1, 1) ("WCCP Disabled.\n");
 	return;
     }
-    if (Config.Wccp.address.ss_family == AF_INET6)
-	((struct sockaddr_in6 *)&Config.Wccp.address)->sin6_port = ntohs(port);
-    else
-	((struct sockaddr_in *)&Config.Wccp.address)->sin_port = ntohs(port);
     theWccpConnection = comm_open(SOCK_DGRAM,
 	IPPROTO_UDP,
-	&Config.Wccp.address,
+	Config.Wccp.address,
+	port,
 	COMM_NONBLOCKING,
 	"WCCP Socket");
     if (theWccpConnection < 0)
@@ -150,7 +147,7 @@
     memset(&router, '\0', router_len);
     router.sin_family = AF_INET;
     router.sin_port = htons(port);
-    router.sin_addr = ((struct sockaddr_in *)&Config.Wccp.router)->sin_addr;
+    router.sin_addr = Config.Wccp.router;
     if (connect(theWccpConnection, (struct sockaddr *) &router, router_len))
 	fatal("Unable to connect WCCP out socket");
     local_len = sizeof(local);
@@ -209,7 +206,7 @@
 	(unsigned) ntohl(wccp_i_see_you.number));
     if (len < 0)
 	return;
-    if (((struct sockaddr_in *)&Config.Wccp.router)->sin_addr.s_addr != from.sin_addr.s_addr)
+    if (Config.Wccp.router.s_addr != from.sin_addr.s_addr)
 	return;
     if (ntohl(wccp_i_see_you.version) != Config.Wccp.version)
 	return;
Index: squid/src/wccp2.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/wccp2.c,v
retrieving revision 1.28.2.3
retrieving revision 1.28.2.4
diff -u -r1.28.2.3 -r1.28.2.4
--- squid/src/wccp2.c	1 Jul 2007 05:44:26 -0000	1.28.2.3
+++ squid/src/wccp2.c	2 Jul 2007 07:37:04 -0000	1.28.2.4
@@ -1,6 +1,6 @@
 
 /*
- * $Id: wccp2.c,v 1.28.2.3 2007/07/01 05:44:26 amosjeffries Exp $
+ * $Id: wccp2.c,v 1.28.2.4 2007/07/02 07:37:04 amosjeffries Exp $
  *
  * DEBUG: section 80    WCCP Support
  * AUTHOR: Steven WIlton
@@ -523,7 +523,7 @@
 void
 wccp2Init(void)
 {
-    sockaddr_storage_list *s;
+    sockaddr_in_list *s;
     char *ptr;
     uint32_t service_flags;
     struct wccp2_service_list_t *service_list_ptr;
@@ -537,7 +537,7 @@
 
     /* Calculate the number of routers configured in the config file */
     for (s = Config.Wccp2.router; s; s = s->next) {
-	if (((struct sockaddr_in *)&s->s)->sin_addr.s_addr != any_addr.s_addr) {
+	if (s->s.sin_addr.s_addr != any_addr.s_addr) {
 	    /* Increment the counter */
 	    wccp2_numrouters++;
 	}
@@ -670,15 +670,15 @@
 
 	/* Add each router.  Keep this functionality here to make sure the received_id can be updated in the packet */
 	for (s = Config.Wccp2.router; s; s = s->next) {
-	    if (((struct sockaddr_in *)&s->s)->sin_addr.s_addr != any_addr.s_addr) {
+	    if (s->s.sin_addr.s_addr != any_addr.s_addr) {
 		wccp2_here_i_am_header.length += sizeof(struct wccp2_router_id_element_t);
 		assert(wccp2_here_i_am_header.length <= WCCP_RESPONSE_SIZE);
 
 		/* Add a pointer to the router list for this router */
 		router_list_ptr->info = (struct wccp2_router_id_element_t *) ptr;
-		router_list_ptr->info->router_address = ((struct sockaddr_in *)&s->s)->sin_addr;
+		router_list_ptr->info->router_address = s->s.sin_addr;
 		router_list_ptr->info->received_id = htonl(0);
-		router_list_ptr->router_sendto_address = ((struct sockaddr_in *)&s->s)->sin_addr;
+		router_list_ptr->router_sendto_address = s->s.sin_addr;
 		router_list_ptr->member_change = htonl(0);
 
 		/* Build the next struct */
@@ -764,13 +764,10 @@
 	debug(80, 2) ("WCCPv2 Disabled.\n");
 	return;
     }
-    if (Config.Wccp2.address.ss_family == AF_INET6)
-	((struct sockaddr_in6 *)&Config.Wccp2.address)->sin6_port = ntohs(port);
-    else
-	((struct sockaddr_in *)&Config.Wccp2.address)->sin_port = ntohs(port);
     theWccp2Connection = comm_open(SOCK_DGRAM,
 	IPPROTO_UDP,
-	&Config.Wccp2.address,
+	Config.Wccp2.address,
+	port,
 	COMM_NONBLOCKING,
 	"WCCPv2 Socket");
     if (theWccp2Connection < 0)
Index: squid/src/auth/digest/auth_digest.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/auth/digest/auth_digest.c,v
retrieving revision 1.4.12.6
retrieving revision 1.4.12.7
diff -u -r1.4.12.6 -r1.4.12.7
--- squid/src/auth/digest/auth_digest.c	1 Jul 2007 05:44:26 -0000	1.4.12.6
+++ squid/src/auth/digest/auth_digest.c	2 Jul 2007 07:37:05 -0000	1.4.12.7
@@ -727,17 +727,16 @@
 		return;
 	    } else {
 		const char *useragent = httpHeaderGetStr(&request->header, HDR_USER_AGENT);
-		static struct sockaddr_storage last_broken_addr;
+		static struct in_addr last_broken_addr;
 		static int seen_broken_client = 0;
 
 		if (!seen_broken_client) {
-		    memset(&last_broken_addr, '\0', sizeof(last_broken_addr)); 
+		    last_broken_addr = no_addr;
 		    seen_broken_client = 1;
 		}
 		if (memcmp(&last_broken_addr, &request->client_addr, sizeof(last_broken_addr)) != 0) {
-		    debug(29, 1) ("\nDigest POST bug detected from %s using '%s'. Please upgrade browser. See Bug #630 for details.\n", sockaddr_ntoa(&request->client_addr), useragent ? useragent : "-");
-		    xmemcpy(&last_broken_addr, &request->client_addr, 
-			SOCKLEN(&request->client_addr));
+		    debug(29, 1) ("\nDigest POST bug detected from %s using '%s'. Please upgrade browser. See Bug #630 for details.\n", inet_ntoa(request->client_addr), useragent ? useragent : "-");
+		    last_broken_addr = request->client_addr;
 		}
 	    }
 	} else {
